﻿
RT_Dialog = {

};

function RT_Dialog:Show( frameName, type, raidid, itemid, what, zone, player, boss )
	local frame = _G[frameName];
	if not frame then return nil end;
	frame:Hide();
	if type then frame.type = type; end
    if what then frame.what = what; end
    if raidid then frame.raidid = raidid; end
    if itemid then frame.itemid = itemid; end
    if zone then frame.zone = zone; end
    if player then frame.player = player; end
    if boss then frame.boss = boss; end
    frame:Show();
end


function RT_Dialog:Edit_OnShow( frame, args )
    local db = KARaidTrackerDB
	local hTitle, hText, text;
	local item, raid;
	if not frame then return end
		
	raid = db.Log[frame.raidid]
	if frame.itemid then
		item = raid.Loot[frame.itemid]
	end

	if frame.type == "raidnote" then
	    hText = "Editing note for \"|c" .. "0000ff00" .. KARaidTracker:GetDisplayDate(raid.Key) .. "|r\"";
		text = raid.note;		
	elseif frame.type == "itemnote" then
	    hText = "Editing note for \"|c" .. item.item.c .. "" .. item.item.name .. "|r\"";
		text = item.note;
	elseif frame.type == "itemcount" then
	    hTitle = "Edit Count";
	    hText = "Editing count for \"|c" .. item.item.c .. "" .. item.item.name .. "|r\"";
		text = item.item.count;
	elseif frame.type == "itemcost" then
	    hTitle = "Edit Cost";
        hText = "Editing cost for \"|c" .. item.item.c .. "" .. item.item.name .. "|r\"";
        text = tostring(item.costs or "");
	elseif frame.type == "playernote" then
	    hText = "Editing note for player \"" .. frame.playerid .. "\"";
		text = raid.PlayerInfos[frame.playerid] and raid.PlayerInfos[frame.playerid].note;
	elseif frame.type == "looter" then
	    hTitle = "Edit Looter";
	    hText = "Editing looter for \"|c" .. item.item.c .. "" .. item.item.name .. "|r\"";
	    text = item.player;
	elseif frame.type == "time" then
		hTitle = "Edit Time";
		if frame.what == "raidend" then
			hText = "Editing End Time (server time)";
			text = KARaidTracker:GetDisplayDate(raid.End);
		elseif frame.what == "raidstart" then
			hText = "Editing Start Time (server time)";
			text = KARaidTracker:GetDisplayDate(raid.Key);
		elseif frame.what == "item" then
			hText = "Editing Item Time (server time)";
			text = KARaidTracker:GetDisplayDate(item.time);
		end
	elseif frame.type == "zone" then
	    hTitle = "Edit Zone";
	    hText = "Editing zone for \"|c" .. "0000ff00" .. "" .. KARaidTracker:GetDisplayDate(raid.Key) .. "|r\"";
	    text = raid.zone;
	elseif frame.type == "export" then
	    hTitle = "Export String";
	    hText = "Showing "..RT_Options.desc.export[db.Options.ExportFormat].." string for upload";
	    if not raid.End then
			KARaidTracker:Print("You have to end the raid before you exporting it");
			frame:Hide(); return;
		end
	    text = RaidTracker_Export:GenerateRaid(raid);
	elseif frame.type == "join" then
		hTitle = "Join";
		hText = "Set details for a join event (server time)";
	elseif frame.type == "leave" then
		hTitle = "Leave";
		hText = "Set details for the leave event (server time)";
	end

	if hTitle then getglobal(frame:GetName().."HeaderTitle"):SetText(hTitle); end
	if hText then getglobal(frame:GetName().."HeaderText"):SetText(hText); end
	if getglobal(frame:GetName().."TextBox") then
		getglobal(frame:GetName().."TextBox"):SetText(text or "");
		getglobal(frame:GetName().."TextBox"):HighlightText();
	end
    PlaySound("UChatScrollButton");

	KARaidTracker:Debug("RT_Dialog:Edit_OnShow",frame:GetName(),frame.raidid,hTitle,hText);
end


function RT_Dialog:Edit_OnSave( frame, option )
    local db = KARaidTrackerDB
	local text, item, raid;
	if not frame then return end
		
	raid = db.Log[frame.raidid]
	if frame.itemid then
		item = raid.Loot[frame.itemid]
	end
	if getglobal(frame:GetName().."TextBox") then
		text = getglobal(frame:GetName().."TextBox"):GetText()
		if text then text = strtrim(text) end
		if strlen(text) == 0 then text = nil end
	end

	if frame.type == "itemnote" then
		item.note = text;
	elseif frame.type == "itemcount" then
		if not text or not tonumber(text) then
			KARaidTracker:Print("Edit Count: Invalid value.");
		else
			item.item.count = tonumber(text);
		end
	elseif frame.type == "itemcost" then
		if text and (not tonumber(text) or not string.find(text, "^(%d+%.?%d*)$")) then
    		KARaidTracker:Print("Edit Costs: Invalid value");
		else
  			item.costs = text
  			if type(dkpp_ctra_sub) == "function" then
  				dkpp_ctra_sub(frame.raidid, frame.itemid);
			end;
		end
		if option == "bank" or option=="disenchant" then item.player = option end
	elseif frame.type == "raidnote" then
		raid.note = text;
	elseif frame.type == "playernote" then
		if not raid.PlayerInfos[frame.playerid] then
			raid.PlayerInfos[frame.playerid] = {};
		end
		raid.PlayerInfos[frame.playerid].note = text;
	elseif frame.type == "looter" then
	    if text then
			item.player = text;
	    end
	elseif frame.type == "time" then
	    if text then
			if not string.find(text, "^(%d+)/(%d+)/(%d+) (%d+):(%d+):(%d+)$") then
			    KarmaUtility:Print("RaidTracker Edit Time: Invalid Time format");
			else
		  		if		frame.what == "raidend" then	raid.End = KARaidTracker:GetTimestamp(text, 0);
				elseif	frame.what == "raidstart" then	raid.Key = KARaidTracker:GetTimestamp(text, 0);
				elseif	frame.what == "item" then		item.time = KARaidTracker:GetTimestamp(text, 0);
				end
			end
		end
	elseif frame.type == "zone" then	
		if text and raid.zone ~= text then			
			if not db.Zones[text] then
				db.Zones[text] = { id=0, pid=0, rel=0, name=text };
				KARaidTracker:Print("Added custom zone: \""..zone.."\"");
			end
		end
		raid.zone = text;
	elseif frame.type == "join" or frame.type == "leave" then
		local name,note,time = RT_JoinLeaveFrameNameEB:GetText(),RT_JoinLeaveFrameNoteEB:GetText(),RT_JoinLeaveFrameTimeEB:GetText();
		if name == nil or strlen(name) == 0 then
			KARaidTracker:Print("KA_RaidTracker Join/Leave: No player");
		elseif not string.find(time, "^(%d+)/(%d+)/(%d+) (%d+):(%d+):(%d+)$") then
			KARaidTracker:Print("KA_RaidTracker Join/Leave: Invalid Time format");
		else
			tinsert( (frame.type == "join") and raid.Join or raid.Leave, { player = name, time = KARaidTracker:GetTimestamp(time, 0) } );
			db.Online[name] = 1;
			KARaidTracker:Print(name.." manual "..frame.type.." at "..time);
			if note and strlen(note) > 0 then
				if not raid.PlayerInfos[name] then
					raid.PlayerInfos[name] = {};
				end
				raid.PlayerInfos[name].note = note;
			end
		end
	end

	KARaidTracker:Debug("RT_Dialog:Edit_OnSave", frame:GetName(), frame.raidid, option);
	
	frame.type = nil;
	frame.what = nil;
	frame.raidid = nil;
	frame.itemid = nil;
	frame.playerid = nil;
	frame.player = nil;			--FIXME: either use playerid consistantly or player
    frame.zone = nil;
    frame.boss = nil;
	
	KA_RaidTracker_Update();
	KA_RaidTracker_UpdateView();	
end


function RT_Dialog:Delete_OnSave( frame )
	local db = KARaidTrackerDB
	local type = frame.type;
	local raid = db.Log[frame.raidid];
	
	if type == "raid" then
		KARaidTracker:DeleteRaidDB(frame.raidid);
	elseif type == "item" then
		table.remove(raid.Loot, frame.itemid);
		for i,v in pairs(raid.Loot) do
			v.id = i;
		end
	elseif type == "player" then
		for k, v in pairs(raid.Join) do
			if v.player == frame.playerid then
				raid.Join[k] = nil;
			end
		end
		for k, v in pairs(raid.Leave) do
			if v.player == frame.playerid then
				raid.Leave[k] = nil;
			end
		end
		if id == db.Options.CurrentRaid then
			db.Online[frame.playerid] = nil;
		end
		if raid.PlayerInfos then
			raid.PlayerInfos[frame.playerid] = nil;
		end
	end
	
	frame.type = nil;
	frame.what = nil;
	frame.raidid = nil;
	frame.itemid = nil;
	frame.playerid = nil;
    frame.zone = nil;
    frame.boss = nil;

	KA_RaidTracker_Update();
	KA_RaidTracker_UpdateView();
end
